import 'package:grizzly/grizzly.dart';

class Person {
  String name;
  int age;
  bool gender;
  double score;

  Person(
      {required this.name,
      required this.age,
      required this.gender,
      required this.score});
}

class PersonTable extends DataTable<Person> {
  late List<String> name = TableCol<Person, String>('name', this,
      getter: (e) => e.name, setter: (e, v) => e.name = v);
  late List<int> age = TableCol<Person, int>('age', this,
      getter: (e) => e.age, setter: (e, v) => e.age = v);
  late List<bool> gender = TableCol<Person, bool>('gender', this,
      getter: (e) => e.gender, setter: (e, v) => e.gender = v);
  late List<double> score = TableCol<Person, double>('score', this,
      getter: (e) => e.score, setter: (e, v) => e.score = v);

  @override
  late List<List> columns = [name, age, gender, score];

  PersonTable(List<Person> inner) : super(inner);
}

void main() {
  final table = PersonTable([
    Person(name: 'Teja', age: 32, gender: true, score: 9.5),
    Person(name: 'Misha', age: 22, gender: true, score: 9.0),
    Person(name: 'Kuroky', age: 35, gender: true, score: 3.4),
    Person(name: 'Shiveer', age: 38, gender: false, score: 10.0),
  ]);
  print(table.name);
  print(table.age.mean);
}
