import 'dart:math';

import 'package:test/expect.dart';
import 'package:test/scaffolding.dart';
import 'package:grizzly/grizzly.dart';

void main() {
  group('bool_iterable', () {
    test('or.equal_length', () {
      final rand = Random(389456);

      final a = rand.bools(10).toList();
      final b = rand.bools(10).toList();
      final c = a | b;
      expect(c, [true, true, true, true, false, false, true, true, true, true]);
    });
    test('or.unequal_length', () {
      final rand = Random(389456);

      final a = rand.bools(10).toList();
      final b = rand.bools(6).toList();
      final c = a | b;
      expect(c, [true, true, true, true, false, false, null, null, null, null]);
    });
    test('and.equal_length', () {
      final rand = Random(389456);

      final a = rand.bools(10).toList();
      final b = rand.bools(10).toList();
      final c = a & b;
      expect(c,
          [false, false, true, true, false, true, true, false, false, false]);
    });
    test('and.unequal_length', () {
      final rand = Random(389456);

      final a = rand.bools(10).toList();
      final b = rand.bools(6).toList();
      final c = a & b;
      expect(
          c, [false, false, true, true, false, true, null, null, null, null]);
    });
  });
}
